<?php
//Transition
function eae_animated_headline_pro_options() {
    $options = [
                    'type'          => __( 'Typing', 'elegant-addons-for-elementor' ),
                    'rotate-1'      => __( 'Rotate', 'elegant-addons-for-elementor' ),
                    'rotate-2'      => __( 'Rotate 2', 'elegant-addons-for-elementor' ),
                    'rotate-3'      => __( 'Rotate 3', 'elegant-addons-for-elementor' ),
                    'loading-bar'   => __( 'Loading Bar', 'elegant-addons-for-elementor' ),
                    'push'          => __( 'Push', 'elegant-addons-for-elementor' ),
                    'scale'         => __( 'Scale', 'elegant-addons-for-elementor' ),
                    'slide'         => __( 'Slide', 'elegant-addons-for-elementor' ),
                    'zoom'          => __( 'Zoom', 'elegant-addons-for-elementor' ),
                    'clip'          => __( 'Clip', 'elegant-addons-for-elementor' ),
                ];

    return $options;
}

//Transition
function eae_button_pro_options() {
    $options = [
                'normal'                => __( 'Normal', 'elegant-addons-for-elementor' ),
                'slide-right'           => __( 'Slide Right', 'elegant-addons-for-elementor' ),
                'slide-from-center'     => __( 'Slide From Center', 'elegant-addons-for-elementor' ),
                'slide-underline'       => __( 'Slide Underline', 'elegant-addons-for-elementor' ),
                'slide-circle'          => __( 'Slide Circle', 'elegant-addons-for-elementor' ),
                'slide-square'          => __( 'Slide Square', 'elegant-addons-for-elementor' ),
            ];

    return $options;
}

// Fancy Title Offset
function eae_fancy_title_offset_pro( $perm ) {

        $perm->add_responsive_control(
            'ct_fancy_title_x_position',
            [
                'label'   => __( 'X Offset', 'elegant-addons-for-elementor' ),
                'type'    => \Elementor\Controls_Manager::SLIDER,
                'default' => [
                    'size' => 0,
                ],
                'tablet_default' => [
                    'size' => 0,
                ],
                'mobile_default' => [
                    'size' => 0,
                ],
                'range' => [
                    'px' => [
                        'min' => -800,
                        'max' => 800,
                    ],
                ],
            ]
        );

        $perm->add_responsive_control(
            'ct_fancy_title_y_position',
            [
                'label'   => __( 'Y Offset', 'elegant-addons-for-elementor' ),
                'type'    => \Elementor\Controls_Manager::SLIDER,
                'default' => [
                    'size' => 0,
                ],
                'tablet_default' => [
                    'size' => 0,
                ],
                'mobile_default' => [
                    'size' => 0,
                ],
                'range' => [
                    'px' => [
                        'min' => -800,
                        'max' => 800,
                    ],
                ],
            ]
        );


        $perm->add_responsive_control(
            'ct_fancy_title_rotation',
            [
                'label'   => __( 'Rotate', 'elegant-addons-for-elementor' ),
                'type'    => \Elementor\Controls_Manager::SLIDER,
                'default' => [
                    'size' => 0,
                ],
                'tablet_default' => [
                    'size' => 0,
                ],
                'mobile_default' => [
                    'size' => 0,
                ],
                'range' => [
                    'px' => [
                        'min'  => -180,
                        'max'  => 180,
                        'step' => 5,
                    ],
                ],
                'selectors' => [
                    '(desktop){{WRAPPER}} .ct-sub-title' => 'transform: translate({{ct_fancy_title_x_position.SIZE}}px, {{ct_fancy_title_y_position.SIZE}}px) rotate({{SIZE}}deg);',
                    '(tablet){{WRAPPER}} .ct-sub-title' => 'transform: translate({{ct_fancy_title_x_position_tablet.SIZE}}px, {{ct_fancy_title_y_position_tablet.SIZE}}px) rotate({{SIZE}}deg);',
                    '(mobile){{WRAPPER}} .ct-sub-title' => 'transform: translate({{ct_fancy_title_x_position_mobile.SIZE}}px, {{ct_fancy_title_y_position_mobile.SIZE}}px) rotate({{SIZE}}deg);',
                ],
            ]
        );
}

// Lightbox Options
function eae_lightbox_options_pro() {
    $options = [
                    'poster' => esc_html__( 'Poster', 'elegant-addons-for-elementor' ),
                    'button' => esc_html__( 'Button', 'elegant-addons-for-elementor' ),
                    'icon'   => esc_html__( 'Icon', 'elegant-addons-for-elementor' ),
            ];

    return $options;
}

// Lightbox Content Options
function eae_lightbox_content_pro() {
    $options = [
                    'image'      => esc_html__( 'Image', 'elegant-addons-for-elementor' ),
                    'youtube'    => esc_html__( 'Youtube', 'elegant-addons-for-elementor' ),
                    'video'      => esc_html__( 'Video', 'elegant-addons-for-elementor' ),
                    'vimeo'      => esc_html__( 'Vimeo', 'elegant-addons-for-elementor' ),
            ];

    return $options;
}

// Testimonial Options
function eae_testimonial_content_pro() {
    $options = [
                    'image_stacked' => __( 'Image Stacked', 'elegant-addons-for-elementor' ),
                    'image_inline'  => __( 'Image Inline', 'elegant-addons-for-elementor' ),
                    'image_above'   => __( 'Image Above', 'elegant-addons-for-elementor' ),
                    'image_left'    => __( 'Image Left', 'elegant-addons-for-elementor' ),
                    'image_right'   => __( 'Image Right', 'elegant-addons-for-elementor' ),
                ];

    return $options;
}

function eae_testimonial_content_template_pro() {
    ?>
    <# if ( settings.ct_testimonial_layout == 'image_left' ) { #>
        <div class="testimonial-content">
            <div class="quote">“</div>
            <div class="ct-testimonial-left">
                <# if( item.ct_elementor_testimonial_enable_avatar == 'yes' ) { #>
                    <div class="ct-author-container">
                        <div class="author-border"></div><!-- /.author-border -->
                        <div class="ct-author-img">
                            <img src="{{item.ct_elementor_avatar.url}}">
                        </div><!-- /.ct-author-img -->
                    </div><!-- /.author-container -->
                <# } #>
                <div class="ct-left-testimonial-content">
                    <div class="testimonial-description ct-text-{{settings.ct_elementor_testimonial_alignment}}">
                        {{{item.ct_elementor_testimonial_description}}}
                    </div><!-- /.testimonial-description -->

                    <div class="author-excerpt ct-block-{{ settings.ct_elementor_testimonial_alignment }} {{ testimonial_layout }}">
                        <# if( item.ct_elementor_testimonial_name.length || item.ct_elementor_testimonial_company_title.length ) { #>
                            <div class="author-details">
                                <# if( item.ct_elementor_testimonial_name.length ) { #>
                                    <span class="testimonial-author">{{item.ct_elementor_testimonial_name}}</span><!-- /.testimonial-author -->
                                <# } #>
                                <# if( item.ct_elementor_testimonial_company_title.length ) { #>
                                    <span class="testimonial-title">{{item.ct_elementor_testimonial_company_title}}</span>
                                <# } #>

                                <# if( item.ct_elementor_estimonial_enable_rating == 'yes' ) { #>
                                    <ul class="ct-star-rating" data-stars="5" data-current="{{ item.ct_elementor_testimonial_rating_number }}"></ul>
                                <# } #>
                            </div><!-- /.author-details -->
                        <# } #>
                    </div><!-- /.author-excerpt -->
                </div><!-- /.ct-left-testimonial-content -->
            </div><!-- /.ct-testimonial-left -->
        </div><!-- /.testimonial-content -->
    <# } #>

    <# if ( settings.ct_testimonial_layout == 'image_right' ) { #>
        <div class="testimonial-content">
            <div class="quote">“</div>
            <div class="ct-testimonial-right">
                <div class="ct-right-testimonial-content">
                    <div class="testimonial-description ct-text-{{settings.ct_elementor_testimonial_alignment}}">
                        {{{item.ct_elementor_testimonial_description}}}
                    </div><!-- /.testimonial-description -->

                    <div class="author-excerpt ct-block-{{ settings.ct_elementor_testimonial_alignment }} {{ testimonial_layout }}">
                        <# if( item.ct_elementor_testimonial_name.length || item.ct_elementor_testimonial_company_title.length ) { #>
                            <div class="author-details">
                                <# if( item.ct_elementor_testimonial_name.length ) { #>
                                    <span class="testimonial-author">{{item.ct_elementor_testimonial_name}}</span><!-- /.testimonial-author -->
                                <# } #>
                                <# if( item.ct_elementor_testimonial_company_title.length ) { #>
                                    <span class="testimonial-title">{{item.ct_elementor_testimonial_company_title}}</span>
                                <# } #>

                                <# if( item.ct_elementor_estimonial_enable_rating == 'yes' ) { #>
                                    <ul class="ct-star-rating" data-stars="5" data-current="{{ item.ct_elementor_testimonial_rating_number }}"></ul>
                                <# } #>
                            </div><!-- /.author-details -->
                        <# } #>
                    </div><!-- /.author-excerpt -->
                </div><!-- /.ct-right-testimonial-content -->

                <# if( item.ct_elementor_testimonial_enable_avatar == 'yes' ) { #>
                    <div class="ct-author-container">
                        <div class="author-border"></div><!-- /.author-border -->
                        <div class="ct-author-img">
                            <img src="{{item.ct_elementor_avatar.url}}">
                        </div><!-- /.ct-author-img -->
                    </div><!-- /.author-container -->
                <# } #>
            </div><!-- /.ct-testimonial-right -->
        </div><!-- /.testimonial-content -->
    <# } #>
    <?php
}


function eae_testimonial_render_pro( $perm, $item ) {
    $settings = $perm->get_settings_for_display();

    if( $settings['ct_testimonial_layout'] == 'image_left' ) :
    ?>
        <div class="testimonial-content">
            <div class="quote">“</div>
            <div class="ct-testimonial-left">
                <?php if( $item['ct_elementor_testimonial_enable_avatar'] == 'yes' ) : ?>
                    <div class="ct-author-container">
                        <div class="author-border"></div><!-- /.author-border -->
                        <div class="ct-author-img">
                            <?php echo \Elementor\Group_Control_Image_Size::get_attachment_image_html( $item, 'ct_elementor_image_size', 'ct_elementor_avatar' ) ?>
                        </div><!-- /.author-img -->
                    </div><!-- /.author-container -->
                <?php endif; ?>
                <div class="ct-left-testimonial-content">
                    <div class="testimonial-description ct-text-<?php echo esc_attr( $settings['ct_elementor_testimonial_alignment'] ); ?>">
                        <?php echo wp_kses_post( $item['ct_elementor_testimonial_description'] ); ?>
                    </div><!-- /.testimonial-description -->

                    <div class="author-excerpt ct-block-<?php echo esc_attr( $settings['ct_elementor_testimonial_alignment'] ); ?> <?php echo $testimonial_layout; ?>">
                        <?php if( !empty( $item['ct_elementor_testimonial_name'] ) || !empty( $item['ct_elementor_testimonial_company_title'] ) ) : ?>
                            <div class="author-details">
                                <?php if( !empty( $item['ct_elementor_testimonial_name'] ) ) : ?>
                                    <span class="testimonial-author"><?php echo esc_html( $item['ct_elementor_testimonial_name'] ); ?></span><!-- /.testimonial-author -->
                                <?php endif; ?>
                                <?php if( !empty( $item['ct_elementor_testimonial_company_title'] ) ) : ?>
                                    <span class="testimonial-title"><?php echo esc_html( $item['ct_elementor_testimonial_company_title'] ); ?></span>
                                <?php endif; ?>

                                <?php if( $item['ct_elementor_estimonial_enable_rating'] == 'yes' ) { ?>
                                    <ul class="ct-star-rating" data-stars="5" data-current="<?php echo esc_attr( $item['ct_elementor_testimonial_rating_number'] ); ?>"></ul>
                                <?php } ?>
                            </div><!-- /.author-details -->
                        <?php endif; ?>
                    </div><!-- /.author-excerpt -->
                </div><!-- /.ct-left-testimonial-content -->
            </div><!-- /.ct-testimonial-left -->
        </div><!-- /.testimonial-content -->
    <?php endif; ?>

    <?php if( $settings['ct_testimonial_layout'] == 'image_right' ) : ?>
        <div class="testimonial-content">
            <?php if( $settings['ct_testimonial_quotation_show'] == 'yes' ) : ?>
            <div class="quote">“</div>
            <?php endif; ?>
            <div class="ct-testimonial-right">
                <div class="ct-right-testimonial-content">
                    <div class="testimonial-description ct-text-<?php echo esc_attr( $settings['ct_elementor_testimonial_alignment'] ); ?>">
                        <?php echo wp_kses_post( $item['ct_elementor_testimonial_description'] ); ?>
                    </div><!-- /.testimonial-description -->

                    <div class="author-excerpt ct-block-<?php echo esc_attr( $settings['ct_elementor_testimonial_alignment'] ); ?> <?php echo $testimonial_layout; ?>">
                        <?php if( !empty( $item['ct_elementor_testimonial_name'] ) || !empty( $item['ct_elementor_testimonial_company_title'] ) ) : ?>
                            <div class="author-details">
                                <?php if( !empty( $item['ct_elementor_testimonial_name'] ) ) : ?>
                                    <span class="testimonial-author"><?php echo esc_html( $item['ct_elementor_testimonial_name'] ); ?></span><!-- /.testimonial-author -->
                                <?php endif; ?>
                                <?php if( !empty( $item['ct_elementor_testimonial_company_title'] ) ) : ?>
                                    <span class="testimonial-title"><?php echo esc_html( $item['ct_elementor_testimonial_company_title'] ); ?></span>
                                <?php endif; ?>

                                <?php if( $item['ct_elementor_estimonial_enable_rating'] == 'yes' ) { ?>
                                    <ul class="ct-star-rating" data-stars="5" data-current="<?php echo esc_attr( $item['ct_elementor_testimonial_rating_number'] ); ?>"></ul>
                                <?php } ?>
                            </div><!-- /.author-details -->
                        <?php endif; ?>
                    </div><!-- /.author-excerpt -->
                </div><!-- /.ct-right-testimonial-content -->
                <?php if( $item['ct_elementor_testimonial_enable_avatar'] == 'yes' ) : ?>
                    <div class="ct-author-container">
                        <div class="author-border"></div><!-- /.author-border -->
                        <div class="ct-author-img">
                            <?php echo \Elementor\Group_Control_Image_Size::get_attachment_image_html( $item, 'ct_elementor_image_size', 'ct_elementor_avatar' ) ?>
                        </div><!-- /.author-img -->
                    </div><!-- /.author-container -->
                <?php endif; ?>
            </div><!-- /.ct-testimonial-right -->
        </div><!-- /.testimonial-content -->
    <?php
    endif;
}

// Slider content repeater style section
function eae_slider_content_pro( $repeater ) {
    $repeater->start_controls_tab( 'style', [ 'label' => __( 'Style', 'elegant-addons-for-elementor' ) ] );

        $repeater->add_control(
            'ct_slider_custom_style',
            [
                'label' => __( 'Custom', 'elegant-addons-for-elementor' ),
                'type' => \Elementor\Controls_Manager::SWITCHER,
                'description' => __( 'Set custom style that will only affect this specific slide.', 'elegant-addons-for-elementor' ),
            ]
        );

        $repeater->add_control(
            'ct_slider_content_position',
            [
                'label' => __( 'Content Position', 'elegant-addons-for-elementor' ),
                'type' => \Elementor\Controls_Manager::SELECT,
                'label_block' => false,
                'options' => [
                    ''              => esc_html__('Default', 'elegant-addons-for-elementor'),
                    'top-left'      => esc_html__('Top Left', 'elegant-addons-for-elementor') ,
                    'top-center'    => esc_html__('Top Center', 'elegant-addons-for-elementor') ,
                    'top-right'     => esc_html__('Top Right', 'elegant-addons-for-elementor') ,
                    'center'        => esc_html__('Center', 'elegant-addons-for-elementor') ,
                    'center-left'   => esc_html__('Center Left', 'elegant-addons-for-elementor') ,
                    'center-right'  => esc_html__('Center Right', 'elegant-addons-for-elementor') ,
                    'bottom-left'   => esc_html__('Bottom Left', 'elegant-addons-for-elementor') ,
                    'bottom-center' => esc_html__('Bottom Center', 'elegant-addons-for-elementor') ,
                    'bottom-right'  => esc_html__('Bottom Right', 'elegant-addons-for-elementor') ,
                ],
                'conditions' => [
                    'terms' => [
                        [
                            'name' => 'ct_slider_custom_style',
                            'value' => 'yes',
                        ],
                    ],
                ],
            ]
        );

        $repeater->add_control(
            'ct_slider_text_align',
            [
                'label' => __( 'Text Align', 'elegant-addons-for-elementor' ),
                'type' => \Elementor\Controls_Manager::CHOOSE,
                'label_block' => false,
                'options' => [
                    'left' => [
                        'title' => __( 'Left', 'elegant-addons-for-elementor' ),
                        'icon' => 'fa fa-align-left',
                    ],
                    'center' => [
                        'title' => __( 'Center', 'elegant-addons-for-elementor' ),
                        'icon' => 'fa fa-align-center',
                    ],
                    'right' => [
                        'title' => __( 'Right', 'elegant-addons-for-elementor' ),
                        'icon' => 'fa fa-align-right',
                    ],
                ],
                'selectors' => [
                    '{{WRAPPER}} {{CURRENT_ITEM}}.ct-slick-slide .slick-slide-container .slick-slide-content' => 'text-align: {{VALUE}}',
                ],
                'conditions' => [
                    'terms' => [
                        [
                            'name' => 'ct_slider_custom_style',
                            'value' => 'yes',
                        ],
                    ],
                ],
            ]
        );

        $repeater->add_control(
            'ct_slider_content_color',
            [
                'label' => __( 'Content Color', 'elegant-addons-for-elementor' ),
                'type' => \Elementor\Controls_Manager::COLOR,
                'selectors' => [
                    '{{WRAPPER}} {{CURRENT_ITEM}} .slick-slide-content .ct-slide-title' => 'color: {{VALUE}}',
                    '{{WRAPPER}} {{CURRENT_ITEM}} .slick-slide-content .ct-slide-description' => 'color: {{VALUE}}',
                    '{{WRAPPER}} {{CURRENT_ITEM}} .slick-slide-content .ct-slide-button' => 'color: {{VALUE}}; border-color: {{VALUE}}',
                ],
                'conditions' => [
                    'terms' => [
                        [
                            'name' => 'ct_slider_custom_style',
                            'value' => 'yes',
                        ],
                    ],
                ],
            ]
        );

        $repeater->add_responsive_control(
            'ct_slider_custom_slides_padding',
            [
                'label' => __( 'Padding', 'elegant-addons-for-elementor' ),
                'type' => \Elementor\Controls_Manager::DIMENSIONS,
                'size_units' => [ 'px', 'em', '%' ],
                'selectors' => [
                    '{{WRAPPER}} {{CURRENT_ITEM}} .slick-slide-container .slick-slide-content' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                ],
                'conditions' => [
                    'terms' => [
                        [
                            'name' => 'ct_slider_custom_style',
                            'value' => 'yes',
                        ],
                    ],
                ],
            ]
        );

        $repeater->end_controls_tab();
}

// Fancy Title Gradient Color
function eae_fancy_title_gradient_options( $perm ) {
    $perm->add_control(
        'ct_fancy_title_gradient_color_switcher',
        [
            'label'        => __( 'Advanced Style', 'bdthemes-element-pack' ),
            'type'         => \Elementor\Controls_Manager::SWITCHER,
            'prefix_class' => 'eae-gradient-color-',
            'render_type'  => 'template',
        ]
    );

    $perm->add_group_control(
        \Elementor\Group_Control_Background::get_type(),
        [
            'name'     => 'ct_fancy_title_gradient_color',
            'selector' => '{{WRAPPER}} .title-area .ct-title, .eae-gradient-color-yes .title-area .ct-title a',
            'condition' => [
                'ct_fancy_title_gradient_color_switcher' => 'yes',
            ],
        ]
    );
}
